#include <QvPerspectiveCamera.h>

QV_NODE_SOURCE(QvPerspectiveCamera);

QvPerspectiveCamera::QvPerspectiveCamera()
{
    QV_NODE_CONSTRUCTOR(QvPerspectiveCamera);
    isBuiltIn = TRUE;

    QV_NODE_ADD_FIELD(position);
    QV_NODE_ADD_FIELD(orientation);
    QV_NODE_ADD_FIELD(focalDistance);
    QV_NODE_ADD_FIELD(heightAngle);
    QV_NODE_ADD_FIELD(nearDistance);
    QV_NODE_ADD_FIELD(farDistance);

    position.value[0] = 0.0F;
    position.value[1] = 0.0F;
    position.value[2] = 1.0F;
    orientation.axis[0] = 0.0F;
    orientation.axis[1] = 0.0F;
    orientation.axis[2] = 1.0F;
    orientation.angle = 0.0F;
    focalDistance.value = 5.0F;
    heightAngle.value = (float) M_PI_4; // 45 degrees

    nearDistance.value = 1.0F;
    farDistance.value = 100.0F;
}

QvPerspectiveCamera::~QvPerspectiveCamera()
{
}
