#include <QvSpotLight.h>

QV_NODE_SOURCE(QvSpotLight);

QvSpotLight::QvSpotLight()
{
    QV_NODE_CONSTRUCTOR(QvSpotLight);
    isBuiltIn = TRUE;

    QV_NODE_ADD_FIELD(on);
    QV_NODE_ADD_FIELD(intensity);
    QV_NODE_ADD_FIELD(color);
    QV_NODE_ADD_FIELD(location);
    QV_NODE_ADD_FIELD(direction);
    QV_NODE_ADD_FIELD(dropOffRate);
    QV_NODE_ADD_FIELD(cutOffAngle);

    on.value = TRUE;
    intensity.value = 1.0F;
    color.value[0] = color.value[1] = color.value[2] = 1.0F;
    location.value[0] = 0.0F;
    location.value[1] = 0.0F;
    location.value[2] = 1.0F;
    direction.value[0] = 0.0F;
    direction.value[1] = 0.0F;
    direction.value[2] = -1.0F;
    dropOffRate.value = 0.0F;
    cutOffAngle.value = (float) (M_PI / 4.0);
}

QvSpotLight::~QvSpotLight()
{
}
