#include <QvUnknownNode.h>

#include <QvField.h>

QV_NODE_SOURCE(QvUnknownNode);

QvUnknownNode::QvUnknownNode()
{
    QV_NODE_CONSTRUCTOR(QvUnknownNode);

    className = NULL;

    // Set global field data to this instance's
    if (QV_NODE_IS_FIRST_INSTANCE())
	delete fieldData;
    instanceFieldData = new QvFieldData;
    fieldData = instanceFieldData;
}

void
QvUnknownNode::setClassName(const char *name)
{
    //strdup caused a heap assertion when the memory is freed in vc4.0.
    //I think we're linking to the wrong library somewhere.  Since we're
    //moving off vc after PDC, this is not worth fixing at this point.
    //className = strdup(name);
    className = (char *)malloc(strlen(name)+1);
    strcpy((char *)className, name);
}

QvUnknownNode::~QvUnknownNode()
{
    for (int i = 0; i < instanceFieldData->getNumFields(); i++)
	delete instanceFieldData->getField(this, i);

    delete instanceFieldData;

    if (className != NULL)
	free((void *) className);
}
